# $Id: Request.pm 42140 2014-09-03 12:19:40Z wsl $
# $URL: https://svn.uvt.nl/its-id/trunk/sources/kiki/lib/UvT/Kiki/WS/Request.pm $

package UvT::Kiki::WS::Request;

use UvT::Kiki::Request -self;

use Email::Sender::Simple qw(sendmail);
use Email::Simple;

sub mailtje {
	my ($subject, $body) = @_;

	return if $self->is_robot;

	my $cfg = $self->cfg;
	my $recipients = $cfg->notification_recipients;
	return unless @$recipients;
	my $sender = $cfg->notification_sender;

	my $mail = Email::Simple->create(
		header => [
			From => $sender,
			To => join(', ', @$recipients),
			Subject => $subject,
		],
		body => $body,
	 );

	eval { sendmail($mail) } or die $@->message;
}
